;*******************************************************
; program ASIX Hrac automat
;*******************************************************
w 		equ 0
f 		equ 1
indf 	equ 0x00 	;registr nepm. adresovn
optreg 	equ 0x01 	;registr option
pcl 	equ 0x02 	;ta programu
status 	equ 0x03
fsr 	equ 0x04	;nepm adresa
porta 	equ 0x05
trisa 	equ 0x05
portb 	equ 0x06
trisb 	equ 0x06
intcon 	equ 0x0B 	;registr zen peruen
tlreg 	equ 0x0C 	;zchytn registr tlatek
cnttl 	equ 0x0D 	;filtr zkmit tlatek
cntd 	equ 0x0E 	;ta multiplexeru
disp1 	equ 0x0F 	;pamt pro 1 sedmisegmentovku
disp2 	equ 0x10 	;pamt pro 2 sedmisegmentovku
disp3 	equ 0x11 	;pamt pro 3 sedmisegmentovku
disp4 	equ 0x12 	;pamt pro 4 sedmisegmentovku
cntd1 	equ 0x13 	;ta 1 sedmisegmentovky
cntd3 	equ 0x14 	;ta 2 sedmisegmentovky
cntd2 	equ 0x15 	;ta 3 sedmisegmentovky
cntd4 	equ 0x16 	;ta 4 sedmisegmentovky
s_w 	equ 0x17 	;stack registru w
s_stat 	equ 0x18 	;stack registru status
s_fsr 	equ 0x19 	;stack registru fsr
cnt1 	equ 0x1A 	;ta asov smyky
cnt2 	equ 0x1B 	;ta asov smyky
cnt3 	equ 0x1C 	;ta asov smyky
cntrot 	equ 0x1D 	;ta rotac
rel1 	equ 0x1E 	;pointer na adresu
rel2 	equ 0x1F 	;pointer na adresu
stack 	equ 0x20 	;zsobnk
cntloop equ 0x21 	;ta prchod smykou
pointer equ 0x22 	;pointer na adresu
cntbl 	equ 0x23 	;ta blikn displeje
led 	equ 0x24 	;registr stavu led
s_trisa equ 0x25 	;stack registru trisa
s_trisb equ 0x26 	;stack registru trisb
;*******************************************************
#define RP0		status,5 	;strnka pamti dat
#define C		status,0
#define Z	    status,2
#define GIE 	intcon,7 	;globln povolen peruen
#define T0IE 	intcon,5 	;povolen peruen timeru0
#define T0IF 	intcon,2 	;flag peteeni timeru0
;*******************************************************
	list p = 16f84
__config 0x3FF1 			;nastaven konfigurace
;*******************************************************
	org 0x0000
	goto Init
;*******************************************************
		org 	0x0004 		;adresa vektoru peruen
Zobraz 	bcf 	T0IF 		;vynulovn flagu timeru0
		movwf 	s_w 		;uloen registru w
		movf 	status,w
		movwf 	s_stat 		;uloen registru status
		movf 	fsr,w
		movwf 	s_fsr 		;uloen registru fsr
		bsf 	RP0 		;vy strnka pamti dat
		movf 	trisa,w
		movwf 	s_trisa 	;uloen registru trisa
		movf 	trisb,w
		movwf 	s_trisb 	;uloen registru trisb
		bcf 	RP0 		;nastaveni ni str.pamti
		incf 	cntd,f 		;pite 1 k it. multiplexeru
		movlw 	0x04
		subwf 	cntd,w
		btfsc 	C 			;je-li C=1,c_disp petekl pes 3
		clrf 	cntd 		;petekl-li c_disp, vynulujeme ;ho
		movlw 	0xFF
		movwf 	porta 		;zhasneme displej
		movlw 	disp1
		movwf 	fsr 		;nepm adresa disp1
		movf 	cntd,w 		;c_disp pekoprujeme do W
		call 	Tab4 		;pekdujeme c_disp -
							;stdav multiplex
		addwf 	fsr,f 		;pite W k nepm adrese disp1
							;vybere tak jeden z registr disp
		movf 	indf,w 		;vybran registr disp do registru W
		call 	Tab1 		;zakdujeme obsah registru na znak
		movwf 	portb 		;poleme znak na port B
		movf 	cntd,w
		call 	Tab2 		;vybereme pslunou anodu
		movf 	led,f
		btfss 	Z 			;testujeme registr led na 0
		addlw 	0x10 		;je-li 0, LED zhasne (RA4=1)
		movwf 	porta 		;sepneme pslun tranzistor
		bsf 	RP0 		;vy strnka pamti dat
		movf 	s_trisa,w
		movwf 	trisa 		;obnoven registru trisa
		movf 	s_trisb,w
		movwf 	trisb 		;obnoven registru trisb
		movf 	s_stat,w
		movwf 	status 		;obnoven registru status
		movf 	s_fsr,w
		movwf 	fsr 		;obnoven registru fsr
		movf 	s_w,w 		;obnoven registru W
		retfie 				;nvrat z peruen
;**********************************************************
Tab1 	addwf 	pcl,f 		;pite W k tai instrukci
		retlw 	B'11000000' ;zobraz 0
		retlw 	B'11111001' ;zobraz 1
		retlw 	B'10100100' ;zobraz 2
		retlw 	B'10110000' ;zobraz 3
		retlw 	B'10011001' ;zobraz 4
		retlw 	B'10010010' ;zobraz 5
		retlw 	B'10000010' ;zobraz 6
		retlw 	B'11111000' ;zobraz 7
		retlw 	B'10000000' ;zobraz 8
		retlw 	B'10010000' ;zobraz 9
		retlw 	B'11111111' ;nezobraz nic
;*******************************************************
Tab2 	addwf 	pcl,f 		;pite W k tai instrukc
		retlw 	B'11111110' ;anoda 1. sedmisegmentovky
		retlw 	B'11111011' ;anoda 3. sedmisegmentovky
		retlw 	B'11111101' ;anoda 2. sedmisegmentovky
		retlw 	B'11110111' ;anoda 4. sedmisegmentovky
;*******************************************************
Tab3 	addwf 	pcl,f 		;tabulka koeficient postupnho
							;zpomalovn rotace
							;sedmisegmentovek
		retlw 	0x03
		retlw 	0x05
		retlw 	0x07
		retlw 	0x09
		retlw 	0x0C
		retlw 	0x0F
		retlw 	0x12
;**********************************************************
Tab4 	addwf 	pcl,f 		;tabulka pekdovn
							;poad registru
							;disp1-4 v pamti dat
		retlw 	0x00
		retlw 	0x02
		retlw 	0x01
		retlw 	0x03
;**********************************************************
Cekej 	movwf 	cnt1 		;naplnn registru 3.smyky
Cekej_A movlw 	0x3c
		movwf 	cnt2 		;naplnn registru 2.smyky
Cekej_B movlw 	0x5B
		movwf 	cnt3 		;naplnn registru 1.smyky
		decfsz 	cnt3,f 		;odete od registru 1.smyky 1
		goto 	$-1 		;sko, je-li registr roven 0
		decfsz 	cnt2,f 		;odete od registru 2.smyky 1
		goto 	Cekej_B 	;sko, je-li registr roven 0
		decfsz 	cnt1,f 		;odete od registru 3.smyky 1
		goto 	Cekej_A 	;sko, je-li registr roven 0
		return 				;nvrat do hlavnho programu
;********************************************************
Cti_tl 	bsf 	RP0 		;vy strnka pamti dat
		movlw 	0xFF
		movwf 	trisb 		;port A vstupn
		movwf 	trisa 		;port B vstupn
		bcf 	RP0 		;ni strnka pamti dat
		movlw 	0x0A
		movwf 	cnttl 		;nastaven filtru zkmit
							;tlatka
		movf 	portb,w 	;peten stavu portu B
		andlw 	0x01 		;zamaskovn nepotebnch bit
Cti_A 	movwf 	tlreg 		;uloen stavu tlatka
		movf 	portb,w
		andlw 	0x01
		subwf 	tlreg,f 	;odeten novho stavu tlatek
		btfss 	Z 			;test shodnosti
		goto 	Cti_tl 		;jsou-li rozdln sko na
							;zatek
		decfsz 	cnttl,f
		goto 	Cti_A 		;opakuje cnttl krt
		movwf 	tlreg 		;ulo stav tlatka
		bsf 	RP0 		;vy strnka pamti dat
		movlw 	0x00
		movwf 	trisa 		;port A vstupn
		movwf 	trisb 		;port A vstupn
		bcf 	RP0 		;ni strnka pamti dat
		return 				;nvrat z podprogramu
;*******************************************************
Init 	bsf 	RP0 		;vy strnka pamti dat
		movlw 	0x00
		movwf 	trisb 		;port B vstupn
		movwf 	trisa 		;port A vstupn
		movlw 	B'11010011'
		movwf 	optreg 		;konfigurace RTCC a peddliky
		bcf 	RP0 		;ni strnka pamti dat
		clrf 	led 		;vynulovn stavu LED
		bcf 	T0IF 		;vynulovn flagu peruen
							;timeru0
		bsf 	T0IE 		;povolen peruen od timeru0
		bsf 	GIE 		;globln povoleni peruen	
;*******************************************************
Main 	movlw 	0x00
		movwf 	cntd1 		;pednastaven
							;1. sedmisegmentovky
		movlw 	0x01
		movwf 	cntd2 		;pednastaven
							;2. sedmisegmentovky
		movlw 	0x02
		movwf 	cntd3 		;pednastaven
							;3. sedmisegmentovky
		movlw 	0x03
		movwf 	cntd4 		;pednastaven
							;4. sedmisegmentovky
		clrf 	cntrot 		;vynulovn tae rotac
		clrf 	cntloop 	;vynulovn tae prchod
							;smykou
		movlw 	cntd4 		;adresa cntd4
		movwf 	pointer 	;uloen adresy do ukazatele
Main_A 	movlw 	cntd1 		;adresa cntd1
		movwf 	rel1 		;uloen adresy do ukazatele
		movlw 	disp1 		;adresa cntd2
		movwf 	rel2 		;uloen adresy do ukazatele
		movf 	pointer,w
		movwf 	fsr 		;nepm adresace aktulnho
							;cntd
		btfss 	indf,6 		;test flagu uloenho v cntd
		goto 	Main_I 		;je-li v pohybu, sko na ;Main_I
		decf 	pointer,f 	;jinak peadresuje pointer
							;na dal cntd
		movf 	pointer,w
		sublw 	(cntd1 - 1)
		btfss 	Z 			;nen-li adresa v pointeru
							;cntd1 men ne
		goto 	Main_J 		;tak sko na Main_J
		movf 	disp1,w 	;jinak testuje registry
							;disp1-disp4
		subwf 	disp2,w
		btfss 	Z
		goto 	Main_G 		;disp1 <> disp2 -> sko na
							;Main_G
		movf 	disp3,w
		subwf 	disp4,w
		btfss 	Z
		goto 	Main_G 		;disp3 <> disp4 -> sko na
							;Main_G
		movf 	disp1,w
		subwf 	disp3,w
		btfss 	Z
		goto 	Main_G 		;disp1 <> disp3 -> sko na
							;Main_G
							;jsou li vechny cntd shodn
							;->
							;vhra!
		movlw 	0x01 		;nastav led tak, aby se po
							;probhnut
		movwf 	led 		;peruen rozsvtila LED
		movf 	disp1,w
		movwf 	stack 		;uloen vtznho sla
Main_B 	movlw 	0x0C
		movwf 	cntbl 		;perioda blikn displeje
		movlw 	0x0A
		movwf 	disp1 		;zhasnut 1.sedmisegmentovky
		movwf 	disp2 		;zhasnut 2.sedmisegmentovky
		movwf 	disp3 		;zhasnut 3.sedmisegmentovky
		movwf 	disp4 		;zhasnut 4.sedmisegmentovky
Main_C 	call 	Cti_tl 		;testovn tlatka
		btfss 	tlreg,0
		goto 	Main_E 		;je-li stisknut, sko na
							;Main_E
		movlw 	0x01
		call 	Cekej 		;chvilku ek
		decfsz 	cntbl,f 	;dekrementuje a testuje cntbl
		goto 	Main_C 		;je-li cntbl=0 -> nikam neske
		movf 	stack,w 	;obnoven stavu displeje
		movwf 	disp1
		movwf 	disp2
		movwf 	disp3
		movwf 	disp4
		movlw 	0x0C 		;perioda blikn displeje
		movwf 	cntbl
Main_D 	call 	Cti_tl 		;testovn tlatka
		btfss 	tlreg,0
		goto 	Main_E 		;je-li stisknut, sko na
							;Main_E
		movlw 	0x01
		call 	Cekej		;chvilku ek
		decfsz 	cntbl,f		;dekrementuje a testuje cntbl
		goto 	Main_D 		;je-li cntbl=0 -> nikam neske
		goto 	Main_B 		;nvrat na Main_B
Main_E 	clrf 	led			;nastav led tak, aby se po
							;probhnut peruen
							;rozsvtila LED
		movlw 	0x0A		;zhasnut sedmisegmentovek
		movwf 	disp1
		movwf 	disp2
		movwf 	disp3
		movwf 	disp4
Main_F 	call 	Cti_tl 		;testovn tlatka
		btfsc 	tlreg,0
		goto 	Main 		;je-li putn,sko na zatek
							;programu
		movlw 	0x01
		call 	Cekej 		;chvilku ek
		goto 	Main_F 		;nvrat na zatek testovac
							;smyky
Main_G 	call 	Cti_tl 		;testovn tlatka
		btfss 	tlreg,0
		goto 	Main_H 		;je-li stisknut, sko na
							;Main_H
		movlw 	0x01
		call 	Cekej 		;chvilku ek
		goto 	Main_G 		;nvrat na zatek smyky
Main_H 	call 	Cti_tl 		;testovn tlatka
		btfsc 	tlreg,0
		goto 	Main 		;je-li putn,sko na zatek
							;programu
		movlw 	0x01
		call 	Cekej 		;chvilku ek
		goto 	Main_H 		;nvrat na zatek testovac
							;smyky
Main_I 	btfsc 	indf,7 		;test flagu uloenho v cntd
		goto 	Main_J 		;je-li nastaven na rychl
							; reim,neske
		call 	Cti_tl 		;testovn tlatka
		btfsc 	tlreg,0
		goto 	Main_J 		;je-li stisknut, nikam neske
		clrf 	cntrot 		;vynulovn tae rotac
		clrf 	cntloop 	;vynulovn tae prchod
							;smykou
		bsf 	indf,7 		;nastaven flagu pomalho bhu
Main_J 	clrw 				;vynuluje W
		call 	Tab3 		;vrt 1. dek tabulky
		call 	Cekej 		;chvilku ek
Main_K 	movf 	rel1,w
		movwf 	fsr 		;postupn nepmo adresuje
							;cntd1-4
		btfsc 	indf,6 		;podle stavu flagu sko na
							;Main_O
		goto 	Main_O 		;skok na Main_O -> bez rotace
		btfss 	indf,7 		;podle stavu flagu sko na
							;Main_M
		goto 	Main_M 		;skok na Main_M->rychl rotace
		movf 	cntrot,w 	;podle obsahu registru cntrot
							;vybere konstantu
		call 	Tab3 		;zpomalen rotace z Tab3
		subwf 	cntloop,w 	;je konstanta shodn s obsahem
							;tae
		btfsc 	Z 			;prchodu smykou???
		goto 	Main_L 		;jestli ano, sko na Main_L
		incf 	cntloop,f 	;jesli ne,inkrementuje ta
							;prchod
		goto 	Main_O 		;smykou a sko na Main_O
Main_L 	clrf 	cntloop 	;vynuluje ta prchod
							;smykou
		incf 	cntrot,f 	;inkrementuje ta rotac
		movf 	cntrot,w
		sublw 	0x07 		;testuje obsah tae rotac
		btfss 	Z
		goto 	Main_M 		;nepetekl-li 6, sko na
							;Main_M
		clrf 	cntrot 		;jinak jej vymae
		bsf 	indf,6 		;nastav flag v aktulnm cntd
							; -> zastaven rotace
Main_M 	incf 	indf,f 		;inkrementuje aktuln cntd
		movf 	indf,w
		andlw 	B'00111111' ;zamaskuje aktuln cntd, aby
							;se neporuily flagy
		sublw 	0x0A
		btfss 	Z 			;jestlie po inkrementovn
							;nepetekl
		goto 	Main_N 		;cntd pres 9 sko na Main_N
		movf 	indf,w 		;jinak si zapamatuje flagy
		andlw 	B'11000000' ;a registr cntd vynuluje
		movwf 	indf 		;flagy ulo nazptek do cntd;
Main_N 	movf 	indf,w
		andlw 	B'00111111' ;zamaskuje aktuln cntd
		movwf 	stack 		;a ulo jej do stacku
		movf 	rel2,w 		;nastav do fsr adresu
		movwf 	fsr 		;aktulnho disp (1-4)
		movf 	stack,w
		movwf 	indf 		;pesune do aktulnho disp
							;obsah stacku
Main_O 	incf 	rel1,f 		;nastav ukazatel na
							;nsledujc cntd
		incf 	rel2,f 		;nastav ukazatel na
							;nsledujc disp
		movf 	rel1,w
		sublw 	(cntd1 + 0x04)
							;testuje, zda ukazatel
							;nepetekl
		btfsc 	Z 			;adresov prostor
							;vyhrazen pro cntd1-4
		goto 	Main_A 		;petekl-li -> sko na Main_A
		goto 	Main_K 		;jinak sko na Main_K
;*******************************************************
	end